/*
 *
 * Copyright (C) 2003 Sadysta ( http://sadysta.ath.cx )
 * Copyright (C) 2007 Tomasz Ostrowski ( http://ostry.w.szu.pl ) - modified from 1.8.9 source
 *
 * This file is part of Free GG.
 *
 * Free GG is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Free GG is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Free GG; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "History.h"
#include "Main.h"

#include <time.h>
#include <math.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
THistoryForm *HistoryForm;
extern AnsiString GGDir;
//---------------------------------------------------------------------------
__fastcall THistoryForm::THistoryForm(TComponent* Owner)
        : TForm(Owner)
{
	bEnableNextSearch = true;
}
//---------------------------------------------------------------------------
void __fastcall THistoryForm::MyWndProc (Messages::TMessage &Msg)
{
    if (Msg.Msg == WM_NOTIFY)
    {
        if (((NMHDR*)Msg.LParam) -> code == EN_LINK)
        {
            ENLINK *E = (ENLINK*)Msg.LParam;
            if (E -> msg == WM_LBUTTONDBLCLK)
                ShellExecute (NULL, NULL, RichEdit1 -> Text.SubString (E -> chrg.cpMin + 1, E -> chrg.cpMax - E -> chrg.cpMin).c_str(), NULL, NULL, SW_SHOW);
        }

    };

    old (Msg);
}
//---------------------------------------------------------------------------
void THistoryForm::PrepareList()
{
    log_file = GGDir;

    TreeView1->Items->Item[0]->DeleteChildren();
    TreeView1->Items->Item[1]->DeleteChildren();

	LogTop = TreeView1 -> Items -> Item[0];
    SMSTop = TreeView1 -> Items -> Item[1];

    TSearchRec F;
    if (FindFirst (log_file + "\\logs\\*", faDirectory, F) == 0)
        do
            if (F.Name != "." && F.Name != "..")
            {
				TTreeNode *T;
                T = TreeView1->Items->AddChild (LogTop, F.Name);
                T -> StateIndex = StrToIntDef (T -> Text, 0);

                for (int i = 0; i < MainForm -> List -> Items -> Count; i++)
                    if (MainForm -> List -> Items -> Item[i] -> SubItems -> Strings[0] == F.Name)
                        T -> Text = MainForm -> List -> Items -> Item[i] -> Caption;

                T -> SelectedIndex = 2;
                T -> ImageIndex = 2;
            }
        while (FindNext (F) == 0);
    FindClose (F);

    if (FindFirst (log_file + "\\sms\\*", faDirectory, F) == 0)
        do
            if (F.Name != "." && F.Name != "..")
            {
                TTreeNode *T;
                T = TreeView1 -> Items -> AddChild (SMSTop, F.Name);
                T -> StateIndex = StrToIntDef (T -> Text, 0);

                for (int i = 0; i < MainForm -> List -> Items -> Count; i++)
                    if (MainForm -> List -> Items -> Item[i] -> SubItems -> Strings[5] == F.Name)
                        T -> Text = MainForm -> List -> Items -> Item[i] -> Caption;

                T -> SelectedIndex = 2;
                T -> ImageIndex = 2;
            }
        while (FindNext (F) == 0);
	FindClose (F);
}

void THistoryForm::ShowContactHistory (AnsiString asId)
{
	if (asId=="")
		return;
	TTreeNode *LogTop = TreeView1 -> Items -> Item[0];
	TTreeNode *T = LogTop->getFirstChild();
	while (T)
	{
		if (T->StateIndex == StrToIntDef(asId, 0))
		{
			T->MakeVisible();
			T->Selected = true;
			if (ListView1->Items->Count)
			{
				ListView1->Items->Item[ListView1->Items->Count-1]->MakeVisible(false);
			}
			break;
		}
		T = LogTop->GetNextChild(T);
	}
}

//---------------------------------------------------------------------------
void __fastcall THistoryForm::EnableNextSearch(TObject *Sender)
{
    bEnableNextSearch = true;
}

//---------------------------------------------------------------------------
AnsiString THistoryForm::GenPreview (AnsiString FileName, INT count, BOOL rtf)
{
    AnsiString ret = "";
    TStringList *S = new TStringList();

    S -> LoadFromFile (FileName);
    for (int i = 0; i < count && i < S -> Count; i++)
        if (rtf)
        {
            int p = S -> Strings[i].Pos ("\\fs20");
            AnsiString c = S -> Strings[i].SubString (p + 5, S -> Strings[i].Length() - p - 4);
            if (c != "" && p != 0)
            {
                while ((p = c.Pos ("\\")) != 0)
                {
                    int x;
                    if (c[p+1] == '\'') x = 4;
                    else x = 7;
                    c = c.SubString (1, p - 1) + c.SubString (p + x, c.Length() - p - x + 1);
                }
                ret += c + " ";
            }
        }
        else ret += S -> Strings[i] + " ";

    if (ret == "") ret = ExtractFileName (FileName);

    delete S;

    return ret;
}
//---------------------------------------------------------------------------
__fastcall TPreviewThread::TPreviewThread(bool CreateSuspended)
        : TThread(CreateSuspended)
{
    this->OnTerminate = HistoryForm->EnableNextSearch;
}
//---------------------------------------------------------------------------
void __fastcall TPreviewThread::Update()
{
    I -> Caption = HistoryForm -> GenPreview (HistoryForm -> log_file + FileName, count, rtf);
    HistoryForm -> StatusBar1 -> Panels -> Items[0] -> Text = IntToStr ((__int64)ceil (p * 100 / HistoryForm -> ListView1 -> Items -> Count));
    HistoryForm -> StatusBar1 -> Repaint();
}
//---------------------------------------------------------------------------
void __fastcall TPreviewThread::Execute()
{
    for (int i = 0; i < HistoryForm -> ListView1 -> Items -> Count; i++)
        if (!Terminated)
        {
            I = HistoryForm -> ListView1 -> Items -> Item[i];
            FileName = I -> SubItems -> Strings[1];
            count = 10;
            p = i + 1;
            Synchronize (&Update);
        }
        else return;

    return;
}
//---------------------------------------------------------------------------
void __fastcall THistoryForm::TreeView1Change(TObject *Sender,
        TTreeNode *Node)
{
    if (Node -> Parent == LogTop || Node -> Parent == SMSTop)
    {
        if (PT != NULL)
        {
            PT -> Terminate();
            while (!bEnableNextSearch)
                Sleep(5);
            delete PT;
            PT = NULL;
        }

        AnsiString Prefix;
        if (Node -> Parent == LogTop) Prefix = "\\logs\\";
        else Prefix = "\\sms\\";

        ListView1 -> Items -> Clear();
        ListView1 -> Tag = Node -> StateIndex;

        TSearchRec F;

        ListView1 -> Items -> BeginUpdate();
        if (FindFirst (log_file + Prefix + IntToStr(Node->StateIndex) + "\\*.*", faArchive, F) == 0)
            do
            {
                TListItem *I = ListView1 -> Items -> Add();
                I -> ImageIndex = 3;
                int time = StrToInt (F.Name.SubString(1, F.Name.Pos('.')-1));
                tm *t = localtime ((long*)&time);
                char asc[64];
                strftime (asc, sizeof(asc), "%d/%m/%y %H:%M:%S", t);
                I -> SubItems -> Add (asc);
                I -> SubItems -> Add (Prefix + IntToStr(Node -> StateIndex) + "\\" + F.Name);
                I -> Caption = F.Name;
            }
            while (FindNext (F) == 0);
        FindClose (F);
        ListView1 -> Items -> EndUpdate();

        StatusBar1 -> SimpleText = "aduj... ";
        PT = new TPreviewThread (true);
        if (Node -> Parent == LogTop) PT -> rtf = true;
        else PT -> rtf = false;
        PT -> Resume();
    }
}
//---------------------------------------------------------------------------

void __fastcall THistoryForm::ListView1Change(TObject *Sender,
        TListItem *Item, TItemChange Change)
{
    if (Change == ctState && Item -> Selected == true)
        try
        {
            RichEdit1 -> Lines -> Clear();
            RichEdit1 -> Lines -> LoadFromFile (log_file + Item -> SubItems -> Strings[1]);
        }
        catch (Exception *E) {}
}
//---------------------------------------------------------------------------

void __fastcall THistoryForm::FormCreate(TObject *Sender)
{
    SendMessage (RichEdit1 -> Handle, EM_AUTOURLDETECT, TRUE, 0);
    SendMessage (RichEdit1 -> Handle, EM_SETEVENTMASK, 0, ENM_LINK);
    old = Panel2 -> WindowProc;
    Panel2 -> WindowProc = MyWndProc;
    StatusBar1 -> DoubleBuffered = true;
}
//---------------------------------------------------------------------------

void __fastcall THistoryForm::ToolButton2Click(TObject *Sender)
{
    PrepareList();
}
//---------------------------------------------------------------------------

void __fastcall THistoryForm::ToolButton3Click(TObject *Sender)
{
    if (ListView1 -> Selected)
        if (MessageBox (Handle, "Czy napewno chcesz usunac ten plik ?", "Potwierdzenie", MB_YESNO | MB_ICONQUESTION) == IDYES)
        {
            DeleteFile (log_file + ListView1 -> Selected -> SubItems -> Strings[1]);
            ListView1 -> Items -> Delete (ListView1 -> Selected -> Index);
        }
}
//---------------------------------------------------------------------------

void __fastcall THistoryForm::ListView1KeyDown(TObject *Sender, WORD &Key,
        TShiftState Shift)
{
    if (Key == VK_DELETE) ToolButton3 -> Click();
}
//---------------------------------------------------------------------------

void __fastcall THistoryForm::StatusBar1DrawPanel(TStatusBar *StatusBar,
        TStatusPanel *Panel, const TRect &Rect)
{
    TCanvas *C = StatusBar -> Canvas;
    TRect R;
    if (StatusBar -> SimpleText == "aduj... ")
    {
        C -> Brush -> Color = clHighlight;
        R = Rect;
        R.Right = R.Left + (R.Width() * StrToIntDef(Panel -> Text, 0) / 100);
        C -> FillRect (R);
        C -> Font -> Color = clWhite;
        C -> TextOut (Rect.Left + 5, Rect.Top, StatusBar -> SimpleText + Panel -> Text + " %");
    }
    else
        C -> TextOut (Rect.Left + 5, Rect.Top, StatusBar -> SimpleText + Panel -> Text);
}
//---------------------------------------------------------------------------

void __fastcall THistoryForm::Button1Click(TObject *Sender)
{
    MainForm->bHistoryIsOpen = false;
    Close();
}
//---------------------------------------------------------------------------
void Search (AnsiString Dir, AnsiString Text)
{
    TSearchRec F;
    AnsiString log_file = HistoryForm -> log_file;

//        ShowMessage (log_file + Dir + "*");

    if (FindFirst (log_file + Dir + "*", faDirectory, F) == 0)
        do
        {
            Application -> ProcessMessages();
            if (F.Name != "." && F.Name != "..")
                if (DirectoryExists (log_file + Dir + F.Name))
                {
                    HistoryForm -> StatusBar1 -> Panels -> Items[0] -> Text = F.Name;
                    Search (Dir + F.Name + "\\", Text);
                }
                else
                {
                    TStringList *L = new TStringList;
                    L -> LoadFromFile (log_file + Dir + F.Name);
                    if (L -> Text.Pos(Text) > 0)
                    {
                        TListItem *I = HistoryForm -> ListView1 -> Items -> Add();
                        I -> Caption = F.Name;
                        long time;
                        time = StrToInt(F.Name.SubString (1, F.Name.Length() - 4));
                        tm *t = localtime (&time);
                        char asc[64];
                        strftime (asc, sizeof(asc), "%d/%m/%y %H:%M:%S", t);
                        I -> SubItems -> Add (asc);
                        I -> SubItems -> Add (Dir + F.Name);
                        I -> ImageIndex = 3;
                    }
                    delete L;
                }
//                MessageBox (HistoryForm -> Handle, F.Name.c_str(), "", 0);
        }
        while (FindNext (F) == 0);
    FindClose (F);
}
//---------------------------------------------------------------------------
void __fastcall THistoryForm::ToolButton1Click(TObject *Sender)
{
    if (PT != NULL)
    {
        PT -> Terminate();
        while (!bEnableNextSearch)
            Sleep(5);
        delete PT;
        PT = NULL;
    }

    StatusBar1 -> SimpleText = "Szukam... ";

    ListView1 -> Items -> BeginUpdate();
    ListView1 -> Items -> Clear();

    PT = new TPreviewThread(true);
    if (r1 -> Checked)
    {
        Search ("\\logs\\", Edit1 -> Text);
        PT -> rtf = true;
    }
    else
    {
        Search ("\\sms\\", Edit1 -> Text);
        PT -> rtf = false;
    }
    ListView1 -> Items -> EndUpdate();
    StatusBar1 -> SimpleText = "aduj... ";
    PT -> Resume();
}
//---------------------------------------------------------------------------

void __fastcall THistoryForm::Edit1KeyDown(TObject *Sender, WORD &Key,
        TShiftState Shift)
{
    if (Key == VK_RETURN) ToolButton1 -> Click();
}
//---------------------------------------------------------------------------

void __fastcall THistoryForm::FormClose(TObject *Sender,
                                        TCloseAction &Action)
{
    MainForm->bHistoryIsOpen = false;
    Action = caFree;
}
//---------------------------------------------------------------------------

void __fastcall THistoryForm::FormShow(TObject *Sender)
{
	PrepareList();
}
//---------------------------------------------------------------------------

